unit SetU;    {A belltsokhoz}

interface

uses Graphics, ExtCtrls, Classes, Dialogs, StdCtrls, SysUtils;

const
  HatterSzin=clWhite;

  AdatDb=2;      {Az RSetting formon bellthat f adatok szma}

  TelepMaxDb=2;
  VonalMaxDb=2;

  VonalVastMin=1; VonalVastMax=20;
  TelepSzelMin=1; TelepSzelMax=20;
  SzovegTavMin=0; SzovegTavMax=40;
  IgazitasDb=4;

type
  TVonalVast=VonalVastMin..VonalVastMax;
  TTelepSzel=TelepSzelMin..TelepSzelMax;
  TSzovegTav=SzovegTavMin..SzovegTavMax;

  TIgazitas=0..IgazitasDb;

const
  IgazitasSzov:array[TIgazitas] of string =
   ('Kzpre','Balra','Jobbra','Le','Fel');

type
  TTelepRec=record
    Szin:TColor;
    Szel:TTelepSzel;
  end;

  TVonalRec=record
    Szin:TColor;
    Vast:TVonalVast;
  end;

  TSzovegFontRec=record
    Keszlet:TFontCharSet;
    Nev:string[50];
    Szin:TColor;
    Magassag:integer;
    Stilus:TFontStyles;
  end;

  TSzovegRec=record
    Kelle:boolean;
    FontRec:TSzovegFontRec;
    Igazitas:TIgazitas;
    Tav:TSzovegTav;
  end;

  {0:alaprtelmezett, 1:kiemelt, 2:'levett' kiemels}
  TSettingRec=record
    TelepDb:0..TelepMaxDb;
    VonalDb:0..VonalMaxDb;
    Telep:array[0..TelepMaxDb] of TTelepRec;
    Vonal:array[0..VonalMaxDb] of TVonalRec;
    Szoveg:TSzovegRec;
    ElTav:TSzovegTav;
  end;

  TSettings=array[1..AdatDb] of TSettingRec;

const
  {Szoveg.Tav:
   - a pontjelleg alapadatoknl (1,4,5) a ponttl val
     eltols rtke az Igazitas irnyban
   - az ljelleg egyb adatoknl (6,7,9,10) az l kzepnek jobbra
     merlegesen eltoland rtke, ahov majd az informcit kirjuk
     (az ElTav is csak itt hasznlatos, a kiemelsi l eltolsi tvja)}

  AlapSettingRec:TSettingRec=
  (TelepDb:TelepMaxDb; VonalDb:VonalMaxDb;
   Telep:((Szin:clGray; Szel:1),(Szin:clGray; Szel:5),(Szin:clGray; Szel:5));
   Vonal:((Szin:clGray; Vast:1),(Szin:clGray; Vast:3),(Szin:clGray; Vast:3));
   Szoveg:(Kelle:false;
           Fontrec:(Keszlet:1; Nev:'MS Sans Serif';
                    Szin:ClBlack; Magassag:8; Stilus:[]);
           Igazitas:0;
           Tav:0);
   ElTav:2);

type
  TSettingsFajl=file of TSettingRec;

procedure Fajlba(FNev:string; const R:TSettings);
procedure Fajlbol(FNev:string; var R:TSettings);
procedure AlapSettings(var R:TSettings);
procedure Pozicio(x,y:integer; var x1,y1:integer; const R:TSzovegRec);
procedure Fontbol(const F:TFont; var SzovegFontRec:TSzovegFontRec);
procedure Fontba(var F:TFont; const SzovegFontRec:TSzovegFontRec);
procedure TelepRajz(var Kep:TImage; R:TTelepRec);
procedure VonalRajz(var Kep:TImage; R:TVonalRec);
procedure ComboBoxBeallit(mit:TComboBox; mettol,meddig,mire:integer);

var
  Settings:TSettings;


implementation

procedure Fajlbol(FNev:string; var R:TSettings);
var f:TSettingsFajl; i:byte;
begin
 AssignFile(f,FNev);
 {$I-} Reset(f); {$I+}
 if IOResult=0 then begin
  for i:=1 to AdatDb do
   Read(f,R[i]);
  CloseFile(f);
 end else
  for i:=1 to AdatDb do R[i]:=AlapSettingRec;
end;

procedure Fajlba(FNev:string; const R:TSettings);
var f:TSettingsFajl; i:byte;
begin
 AssignFile(f,FNev);
 Rewrite(f);
 for i:=1 to AdatDb do
  Write(f,R[i]);
 CloseFile(f)
end;

procedure AlapSettings(var R:TSettings);
var i:integer;
begin
 for i:=1 to AdatDb do R[i]:=AlapSettingRec;
 {Szin, vonalvastagsg, szvegtvolsg finomtsok}
 R[1].Telep[1].Szin:=clRed;        {Pont}
 R[1].Szoveg.FontRec.Szin:=clRed;
 R[2].Vonal[1].Szin:=clBlue;       {Szakasz}
 R[2].Szoveg.FontRec.Szin:=clBlue;
end;

procedure Pozicio(x,y:integer; var x1,y1:integer; const R:TSzovegRec);
begin
 with R do
  case Igazitas of
   0:begin x1:=x; y1:=y; end;               {'Kzpre'}
   1:begin x1:=x-Tav; y1:=y; end;           {'Balra'}
   2:begin x1:=x+Tav; y1:=y; end;           {'Jobbra'}
   3:begin x1:=x; y1:=y+Tav; end;           {'Le'}
   4:begin x1:=x; y1:=y-Tav; end;           {'Fel'}
  end;
end;

procedure Fontbol(const F:TFont; var SzovegFontRec:TSzovegFontRec);
begin
 with F,SzovegFontRec do begin
  Keszlet:=Charset;
  Nev:=Name;
  Szin:=Color;
  Magassag:=Height;
  Stilus:=Style;
 end;
end;

procedure Fontba(var F:TFont; const SzovegFontRec:TSzovegFontRec);
begin
 with F,SzovegFontRec do begin
  Charset:=Keszlet;
  Name:=Nev;
  Color:=Szin;
  Height:=Magassag;
  Style:=Stilus;
 end;
end;

procedure TelepRajz(var Kep:TImage; R:TTelepRec);
begin
 with Kep.Canvas,R do begin
  {Trls}
  Brush.Style:=bsSolid;
  Brush.Color:=HatterSzin;
  FillRect(Rect(0,0,Kep.Width,Kep.Height));
  {Rajzols}
  if Szel=1 then
   Pixels[Kep.Width div 2,Kep.Height div 2]:=Szin
  else begin
   Brush.Color:=Szin;
   FillRect(Rect(Kep.Width div 2 - Szel div 2,
                 Kep.Height div 2 - Szel div 2,
                 Kep.Width div 2 + Szel div 2,
                 Kep.Width div 2 + Szel div 2));
  end;
  {Keretvonal}
  Pen.Color:=clDkGray;
  Pen.Width:=1;
  Polyline([Point(0,0),Point(Kep.Width-1,0),
            Point(Kep.Width-1,Kep.Height-1),Point(0,Kep.Height-1),
            Point(0,0)]);
 end;
end;

procedure VonalRajz(var Kep:TImage; R:TVonalRec);
begin
 with Kep.Canvas,R do begin
  {Trls}
  Brush.Style:=bsSolid;
  Brush.Color:=HatterSzin;
  FillRect(Rect(0,0,Kep.Width,Kep.Height));
  {Rajzols}
  Pen.Color:=Szin;
  Pen.Width:=Vast;
  MoveTo(0,Kep.Height div 2);
  LineTo(Kep.Width,Kep.Height div 2);
  {Keretvonal}
  Pen.Color:=clDkGray;
  Pen.Width:=1;
  Polyline([Point(0,0),Point(Kep.Width-1,0),
            Point(Kep.Width-1,Kep.Height-1),Point(0,Kep.Height-1),
            Point(0,0)]);
 end;
end;

{A mit-be a mettol..meddig rtkeket, ItemIndex-be a mire indext}
procedure ComboBoxBeallit(mit:TComboBox; mettol,meddig,mire:integer);
var i,j:integer; van:boolean;
begin
 j:=0; mit.Clear; van:=false;
 for i:=mettol to meddig do begin
  mit.Items[j]:=IntToStr(i);
  if i=mire then begin
   mit.ItemIndex:=j; van:=true;
  end;
  inc(j);
 end;
 if not van then begin
  {ilyen eset elvileg nem lehet}
  MessageDlg('Hiba a ComboBoxBeallit-ban!',mtError,[mbOk],0);
  mit.ItemIndex:=0;
 end;
end;

end.
