unit SettingU;     {Rajzbelltsok formja}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,
  SegedU, SetU, SetKepU;

const CfgDefault='CfgDefault.set'; Kit='set';

type
  TSettingForm = class(TForm)
    GroupBox1: TGroupBox;
    Image1_0: TImage;
    Image1_1: TImage;
    Image1_2: TImage;
    Image2_0: TImage;
    Image2_2: TImage;
    Image2_1: TImage;
    ComboBox1_1: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label0_1: TLabel;
    Label0_2: TLabel;
    Label0_3: TLabel;
    Label0_4: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonBetolt: TButton;
    ButtonKiment: TButton;
    ButtonAlapBe: TButton;
    ButtonAlapKi: TButton;
    ButtonOk: TButton;
    ButtonMegsem: TButton;
    FontDialog1: TFontDialog;
    ComboBox1_2: TComboBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure PanelKezelo(Sender: TObject);
    procedure CheckBoxKezelo(Sender: TObject);
    procedure ComboBoxKezelo(Sender: TObject);
    procedure ButtonAlapBeClick(Sender: TObject);
    procedure ButtonBetoltClick(Sender: TObject);
    procedure ButtonKimentClick(Sender: TObject);
    procedure ButtonMegsemClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonAlapKiClick(Sender: TObject);
  private
    { Private declarations }
    R:TSettings; {Az aktulis belltsok ideiglenes mentshez}
    procedure PanelSzinAllit(s,o:byte);
    procedure ImageSzinAllit(s:byte);
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);
    procedure Formra(var R:TSettings);
  end;

implementation

uses NagyitasU;

{$R *.DFM}

{Az sszes kpernyelem kiraksa az R alapjn}
procedure TSettingForm.Formra(var R:TSettings);
var i,s,o:integer; neve:string;
    kep:TImage; f:Tfont;
begin
 for i:=0 to ComponentCount-1 do begin
  neve:=Components[i].Name;
  Szamot(neve,s,o);
  if s in [1..adatdb] then
   with R[s] do begin
    if Copy(neve,1,5)='Image' then begin
     kep:=Components[i] as TImage;
     case s of
      1:TelepRajz(kep,R[s].Telep[o]);
      2:VonalRajz(kep,R[s].Vonal[o]);
     end;
    end else
    if Copy(neve,1,5)='Panel' then begin
     f:=TPanel(Components[i]).Font;
     Fontba(f,Szoveg.Fontrec);
     TPanel(Components[i]).Enabled:=Szoveg.Kelle
    end else
    if (Copy(neve,1,5)='Check') then begin
     TCheckBox(Components[i]).Checked:=Szoveg.Kelle;
    end else
    if Copy(neve,1,5)='Combo' then begin
     with TComboBox(Components[i]) do begin
      if o=1 then begin
       {Igazts}
       Enabled:=Szoveg.Kelle;
       ItemIndex:=Szoveg.Igazitas;
      end else begin
       {Tvolsg}
       Enabled:=Szoveg.Kelle and (Szoveg.Igazitas>0);
       ItemIndex:=Szoveg.Tav;
      end;
     end;
    end;
   end;
 end;
end;

procedure TSettingForm.PanelKezelo(Sender: TObject);
var s,o:integer; neve:string; p:TPanel;
begin
 p:=Sender as TPanel;
 neve:=p.Name;
 Szamot(neve,s,o);
 p.BevelOuter:=bvLowered;
 {Arra a Font-ra lljunk a Font vlasztsnl, amelyiket vltoztatjuk}
 FontDialog1.Font:=p.Font;
 if FontDialog1.Execute then begin
  p.Font:=FontDialog1.Font;
  Fontbol(p.Font,Settings[s].Szoveg.FontRec);
  {A megfelel (s uaz, o pedig 1)telep, vonal szine is vltozzon}
  ImageSzinAllit(s);
 end;
 p.BevelOuter:=bvRaised;
end;

procedure TSettingForm.CheckBoxKezelo(Sender: TObject);
var s,o:integer;
begin
 with Sender as TCheckBox do begin
  Szamot(Name,s,o);
  case s of
   1:begin
      Panel1.Enabled:=Checked;
      ComboBox1_1.Enabled:=Checked;
      ComboBox1_2.Enabled:=Checked and (Combobox1_1.ItemIndex>0);
     end;
   2:begin
      Panel2.Enabled:=Checked;
     end;
  end;
  Settings[s].Szoveg.Kelle:=Checked;
 end;
end;

procedure TSettingForm.ComboBoxKezelo(Sender: TObject);
var s,o:integer;
begin
 with Sender as TComboBox do begin
  Szamot(Name,s,o);
  if o=1 then begin
   {Igazts}
   case s of
    1:ComboBox1_2.Enabled:=ItemIndex>0;
   end;
   Settings[s].Szoveg.Igazitas:=ItemIndex;
  end else begin
   {o=2}
   {Szvegtvolsg}
   Settings[s].Szoveg.Tav:=StrToInt(Items[ItemIndex]);
  end;
 end;
end;

{A megfelel Panel betszine is vltozzon}
procedure TSettingForm.PanelSzinAllit(s,o:byte);
begin
 case s of
  1:if o=1 then begin
     Panel1.Font.Color:=Settings[s].Telep[o].Szin;
     Settings[s].Szoveg.FontRec.Szin:=Settings[s].Telep[o].Szin;
    end;
  2:if o=1 then begin
     Panel2.Font.Color:=Settings[s].Vonal[o].Szin;
     Settings[s].Szoveg.FontRec.Szin:=Settings[s].Vonal[o].Szin;
    end;
 end;
end;

{A megfelel telepls, vonal kiemels szine is vltozzon}
procedure TSettingForm.ImageSzinAllit(s:byte);
begin
 case s of
  1:begin
     Settings[s].Telep[1].Szin:=Panel1.Font.Color;
     TelepRajz(Image1_1,Settings[s].Telep[1]);
    end;
  2:begin
     Settings[s].Vonal[1].Szin:=Panel2.Font.Color;
     VonalRajz(Image2_1,Settings[s].Vonal[1]);
    end;
 end;
end;

procedure TSettingForm.ImageClick(Sender: TObject);
var i,s,o,s1,o1,oo:integer; Kep,Kep1:TImage;
    SetKepForm:TSetKepForm;
begin
 Kep:=Sender as TImage;
 Szamot(Kep.Name,s,o);
 case s of
  1:begin
     SetKepForm:=TSetKepForm.Create(Self,true,Settings[s].Telep[o].Szel);
     SetKepForm.TelepRec:=Settings[s].Telep[o];
     TelepRajz(SetKepForm.Image1,SetKepForm.TelepRec);
    end;
  2:begin
     SetKepForm:=TSetKepForm.Create(Self,false,Settings[s].Vonal[o].Vast);
     SetKepForm.VonalRec:=Settings[s].Vonal[o];
     VonalRajz(SetKepForm.Image1,SetKepForm.VonalRec);
    end;
 end;
 SetKepForm.ActiveControl:=SetKepForm.ButtonOK;
 if SetKepForm.ShowModal=mrOk then begin
  case s of
   1:begin
      Settings[s].Telep[o]:=SetKepForm.TelepRec;
      TelepRajz(Kep,Settings[s].Telep[o]);
     end;
   2:begin
      Settings[s].Vonal[o]:=SetKepForm.VonalRec;
      VonalRajz(Kep,Settings[s].Vonal[o]);
     end;
  end;
  {A megfelel Panel betszine is vltozzon}
  PanelSzinAllit(s,o);
  {Az Elz kiemels ezeknl uolyan vastag legyen mint a kiemels}
  oo:=3-o;
  if oo in [1,2] then
   for i:=0 to ComponentCount-1 do
    if copy(Components[i].Name,1,5)='Image' then begin
     Szamot(Components[i].Name,s1,o1);
     if (s1=s) and (o1=oo) then begin
      Kep1:=Components[i] as TImage;
      case s of
       1:begin
          Settings[s].Telep[oo].Szel:=Settings[s].Telep[o].Szel;
          TelepRajz(Kep1,Settings[s].Telep[oo]);
         end;
       2:begin
          Settings[s].Vonal[oo].Vast:=Settings[s].Vonal[o].Vast;
          VonalRajz(Kep1,Settings[s].Vonal[oo]);
         end;
      end;
     end;
    end;
 end;
 SetKepForm.Free;
end;

procedure TSettingForm.ButtonBetoltClick(Sender: TObject);
var st:string;
begin
 OpenDialog1.Filter:='Bellts fjlok (*.'+Kit+')|*.'+UpperCase(Kit);
 OpenDialog1.InitialDir:=RajzForm.Konyvtar;
 OpenDialog1.FileName:='';
 if OpenDialog1.Execute then begin
  RajzForm.SettingNev:=OpenDialog1.FileName;
  Fajlbol(RajzForm.SettingNev,Settings);
  Formra(Settings);
  R:=Settings;
  Caption:=ExtractFileName(RajzForm.SettingNev);
 end;
end;

procedure TSettingForm.ButtonKimentClick(Sender: TObject);
var st:string;
begin
 SaveDialog1.Filter:='Bellts fjlok (*.'+Kit+')|*.'+UpperCase(Kit);
 SaveDialog1.InitialDir:=RajzForm.Konyvtar;
 SaveDialog1.FileName:='';
 if SaveDialog1.Execute then begin
  st:=SaveDialog1.FileName;
  if UpperCase(Copy(st,length(st)-2,3))<>UpperCase(Kit) then
   st:=st+'.'+Kit;
  RajzForm.SettingNev:=st;
  Fajlba(RajzForm.SettingNev,Settings);
  R:=Settings;
  Caption:=ExtractFileName(RajzForm.SettingNev);
 end;
end;

procedure TSettingForm.ButtonMegsemClick(Sender: TObject);
begin
 Settings:=R;
 ModalResult:=mrCancel;
end;

procedure TSettingForm.ButtonOkClick(Sender: TObject);
begin
 Fajlba(RajzForm.SettingNev,Settings);
 RajzForm.KepRajzol;
 ModalResult:=mrOk;
end;

procedure TSettingForm.ButtonAlapKiClick(Sender: TObject);
begin
 RajzForm.SettingNev:=RajzForm.Konyvtar+'\'+CfgDefault;
 Fajlba(RajzForm.SettingNev,Settings);
 Caption:=ExtractFileName(RajzForm.SettingNev);
end;

procedure TSettingForm.ButtonAlapBeClick(Sender: TObject);
begin
 RajzForm.SettingNev:=RajzForm.Konyvtar+'\'+CfgDefault;
 Fajlbol(RajzForm.SettingNev,Settings);
 Caption:=ExtractFileName(RajzForm.SettingNev);
 Formra(Settings);
end;

{A SzvegTavMin=0 miatt a tvolsg ComboBox-ok ItemIndexe-i}
{ppen a kvnt/kivlasztott tvolsg rtkeknek felelnek meg}
constructor TSettingForm.Create(AOwner:TComponent);
var i,s,o:integer; neve:string; k:TIgazitas;
    BM:TBitMap;
begin
 inherited Create(AOwner);
 {Form belltsok}
 for i:=0 to ComponentCount-1 do begin
  neve:=Components[i].Name;
  Szamot(neve,s,o);
  if copy(neve,1,5)='Image' then
   with Components[i] as TImage do begin
    BM:=TBitMap.Create;
    BM.Width:=Width;
    BM.Height:=Height;
    Picture.Graphic:=BM;
   end
  else
  if copy(neve,1,5)='Panel' then begin
   if o=0 then
    TPanel(Components[i]).Caption:='A'
  end else
  if copy(neve,1,5)='Combo' then begin
   if o=1 then begin
    {Igaztsok}
    for k:=0 to IgazitasDb do
     TComboBox(Components[i]).Items[k]:=IgazitasSzov[k];
   end else begin
    {Tvolsgok}
    ComboBoxBeallit(TComboBox(Components[i]),SzovegTavMin,
      SzovegTavMax,SzovegTavMin);
   end;
   TComboBox(Components[i]).ItemIndex:=0;
  end;
 end;
 {Az aktulis belltst megjegyezzk a Mgsem esetre}
 {Ez mindig ltezik (lsd: RajzForm.Create)}
 R:=Settings;
 Formra(Settings);
 Caption:=ExtractFileName(RajzForm.SettingNev);
end;

procedure TSettingForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Action:=caFree;
end;

end.

