unit Valasztas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

{Megjegyzsek:
 - Ha a DragMode=dmManual (alaprtelmezs), akkor a BeginDrag,
   metdus hvsval (pl. az OnMouseDown esemnykezelbl)
   kezdhet a fogd s vidd mvelet.
 - Ha a DragMode=dmAutomatic, akkor az automatikusan elindul
   ha az adott vezrl fltt lenyomjuk az egr bal gombjt.
 - Egy fogd s vidd mvelet addig tart amg fel nem engedjk
   az egr bal gombjt. Ez az elejts (drop).
 - Azt, hogy egy vezrl megengedi-e az elejtst, azaz hogy
   fltte befejezhet-e egy fogd s vidd mveletet, az attl
   fgg, hogy az OnDragOver esemnykezeljben hogyan lltjuk
   be az Accept paramter rtkt. True esetn megengedi a
   leejtst, ha ilyenkor leejtjk, akkor meghvdik a vezrl
   OnDragDrop esemnykezelje, egybknt (false) nem.
 - Azok a vezrlk, amelyeknek nincs OnDragOver esemnykezelje,
   azok alaprtelmezsben elutastjk a leejtst.
 - Ha az elejts megengedett egy vezrl felett, akkor a fogd
   s vidd mvelet egrkurzora a mveletet kezd (Source)
   vezrl DragCursor tulajdonsga alapjn jelenik meg,
   klnben az egrkurzor a crNoDrag rtk ltal definilt,
   jelezvn, hogy ott nincs megengedve az elejts.
 - A DragCursor alaprtelmezett rtke a crDrag de ez szabadon
   megvltoztathat akr a fogd s vidd mvelet sorn is.
 - A tnyleges tennivalk, amelyek elvgzst a felhasznl
   kri a fogd s vidd mvelettel, a fogad vezrl OnDragDrop
   esemnykezeljben programozandk.
 - Egy elkezdett fogd s vidd mvelet befejezhet programbl
   is, br nem igen szoks, hiszen ekkor a mvelet megszakad,
   hiba tartja lenyomva a felhasznl az egr bal gombjt.
   A mveletet kezd vezrl EndDrag metdust kell meghvni,
   amelynek paramtere (Drop) hatrozza meg azt, hogy
   elfogadjuk-e a leejtst vagy sem. Ha elfogadjuk (true),
   akkor meghvdik annak az objektumnak az OnDragDrop
   esemnykezelje, amelynek OnDragOver esemnykezeljbl
   meghvtuk az EndDrag metdust.}

type
  TValasztasForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    lbHonnan: TListBox;
    lbHova: TListBox;
    bbnOda: TBitBtn;
    bbnVissza: TBitBtn;
    bbnLe: TBitBtn;
    bbnFel: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure AtteszKezelo(Sender: TObject);
    procedure BillKezelo(Sender: TObject; var Key: Char);
    procedure DragDropKezelo(Sender, Source: TObject; X, Y: Integer);
    procedure DragOverKezelo(Sender, Source: TObject;
      X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    procedure Attesz(Honnan,Hova:TListBox);
    procedure Leptet(fel:boolean; lb:TListBox);
    procedure Kijelolt(lb:TListBox; var db,index:integer);
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; Valasztek:TStrings;
     Fejlec,HonnanFelirat,HovaFelirat:string);
  end;

implementation

{$R *.DFM}

{Elem(ek) tttele az egyik listbox-bl a msikba}
procedure TValasztasForm.Attesz(Honnan,Hova:TListBox);
var i:integer;
begin
 i:=1;
 while i<=Honnan.Items.Count do
  if Honnan.Selected[i-1] then begin
   Hova.Items.Add(Honnan.Items[i-1]);
   Honnan.Items.Delete(i-1);
  end else inc(i);
end;

{A kijellt elemek db szma s az utols kiemelt indexe}
procedure TValasztasForm.Kijelolt(lb:TListBox; var db,index:integer);
var i:integer;
begin
 db:=0; index:=0;
 for i:=1 to lb.Items.Count do
  if lb.Selected[i-1] then begin
   inc(db); index:=i-1;
  end;
end;

{Egy kijellt elem lptetse eggyel feljebb/lejjebb}
procedure TValasztasForm.Leptet(fel:boolean; lb:TListBox);
var i,j,jelolt:integer; cs:string;
begin
 Kijelolt(lb,jelolt,i);
 {csak egy lehet kijellve, azt lptetjk fel vagy le}
 if jelolt=1 then
  with lb do begin
   if fel then begin
    if i>0 then begin
     cs:=Items[i-1]; Items[i-1]:=Items[i]; Items[i]:=cs; j:=i-1;
    end else j:=0;
   end else begin
    if i<Items.Count-1 then begin
     cs:=Items[i+1]; Items[i+1]:=Items[i]; Items[i]:=cs; j:=i+1;
    end else j:=Items.Count-1;
   end;
   {amit lptettnk, az maradjon tovbbra is a kijellt}
   lb.Selected[j]:=true;
  end;
end;

{Az ttev, lptet TBitButton gombok kattintshoz s}
{a listbox-ok duplakattintshoz rendelt esemnykezel}
procedure TValasztasForm.AtteszKezelo(Sender: TObject);
var nev:string;
begin
 if Sender is TBitBtn then begin
  nev:=TBitBtn(Sender).Name;
  if nev='bbnOda' then Attesz(lbHonnan,lbHova) else
  if nev='bbnVissza' then Attesz(lbHova,lbHonnan) else
  if nev='bbnFel' then Leptet(true,lbHova) else
  if nev='bbnLe' then Leptet(false,lbHova);
 end else
 if Sender is TListBox then begin
  nev:=TListBox(Sender).Name;
  if nev='lbHonnan' then Attesz(lbHonnan,lbHova) else
  if nev='lbHova' then Attesz(lbHova,lbHonnan);
 end;
end;

{Billentyzet kezel a listbox-okhoz}
procedure TValasztasForm.BillKezelo(Sender: TObject; var Key: Char);
begin
 if ord(Key)=13 {Enter} then begin
  {Ehhez az is kell, hogy ne legyen Default nyomgomb a formon!}
  if TListBox(Sender).Name=lbHonnan.Name then
   Attesz(lbHonnan,lbHova)
  else Attesz(lbHova,lbHonnan);
 end;
end;

{Csak ListBox-ok lehetnek a Drag esemnyek Source s Sender}
{objektumai, hiszen csak nluk definiltuk a DragMode-ot}
{dmAutomatic-ra, ill. csak hozzjuk rendeltnk ilyen}
{esemnykezelket (DragOverKezelo, DragDropKezelo)}

procedure TValasztasForm.DragOverKezelo(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
var cr:TCursor; db,i:integer;
begin
 if State=dsDragEnter then begin
  {Csak kezds/belps esetn lltunk DragCursor-t}
  Kijelolt(TListBox(Source),db,i);
  case db of
   0:cr:=crNoDrop;
   1:cr:=crDrag;
   else cr:=crMultiDrag;
  end;
  TListBox(Source).DragCursor:=cr;
 end;
 {Csak a msik listbox-ba trtn Drop-ot engedjk}
 Accept:=TListBox(Source).Name<>TListBox(Sender).Name;
end;

procedure TValasztasForm.DragDropKezelo(Sender, Source: TObject;
  X, Y: Integer);
begin
 if TListBox(Sender).Name='lbHova' then
  Attesz(lbHonnan,lbHova)
 else Attesz(lbHova,lbHonnan);
end;

procedure TValasztasForm.BitBtn1Click(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

procedure TValasztasForm.BitBtn2Click(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TValasztasForm.Create(AOwner:TComponent;
 Valasztek:TStrings; Fejlec,HonnanFelirat,HovaFelirat:string);
begin
 inherited Create(AOwner);
 lbHonnan.Items.Assign(Valasztek);
 {A vlasztk rendezett legyen}
 lbHonnan.Sorted:=true;
 Caption:=Fejlec;
 Label1.Caption:=HonnanFelirat;
 Label2.Caption:=HovaFelirat;
end;

end.
  