unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Alakzatok, Menus;

{Az alakzatok maximlis darabszma, mrethatrai (sugr, szlessg, magassg)}
const Db=15; Min=5; Max=50;

{A vletlen generlshoz}
const Tav=20;

{Az idzt esemnye ennyi ezredmsodpercenknt fut majd le}
const Ido=100;

{Sajt szntmb 16 db sznnel a Turbo Pascal szneihez hasonlan}
const Szinek:array[0..15] of TColor=
       (clBlack,clBlue,clGreen,clNavy,clRed,clPurple,clMaroon,clGray,
        clAqua,clLime,clSilver,clFuchsia,clTeal,clYellow,clLtGray,clWhite);
      HatterSzin=clNavy;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    {Az alakzatok listja}
    AlakzatLista:TList;
    {Az idzt objektum}
    Ora:TTimer;
    {A rajzolsi terlet mretnek lekrdezse}
    function GetMaxX:integer;
    function GetMaxY:integer;
    {Egy vletlen alakzat (pont, kr, tglalap) generlsa}
    function General:TPont;
    {Az alakzat lista feltltse vletlen alakzatokkal}
    procedure ListaGeneralas(Adb:word);
    {Az alakzatok szmt a fejlcbe}
    procedure Fejlec;
    {Az alakzatok kirajzolsa}
    procedure Kirajzolas;
    {Egy mozgatsi lps}
    procedure EgyLepes(Sender: TObject);
    {Az alakzat lista elemeinek trlse}
    procedure ListaTorles;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{A rajzterlet maximlis szlessge}
function TForm1.GetMaxX:integer;
begin
 {Mivel az Image1-re rajzolunk}
 Result:=Image1.Width;
end;

{A rajzterlet maximlis magassga}
function TForm1.GetMaxY:integer;
begin
 {Mivel az Image1-re rajzolunk}
 Result:=Image1.Height;
end;

{Egy vletlen alakzat (pont, kr, tglalap) generlsa}
function TForm1.General:TPont;
var sz:byte;
begin
 {Egy vletlen, nem httrszn sznt}
 repeat
  sz:=random(16);
 until Szinek[sz]<>Image1.Canvas.Brush.Color;
 {Pont, kr, teli kr, tglalap, teli tglalap egyforma arnyban}
 case random(5)+1 of
  1:Result:=TPont.Create(random(GetMaxX),random(GetMaxY),Szinek[sz]);
  2:Result:=TKor.Create(random(GetMaxX),random(GetMaxY),
                        random(Max-Min)+Min,Szinek[sz]);
  3:Result:=TTeliKor.Create(random(GetMaxX),random(GetMaxY),
                            random(Max-Min)+Min,Szinek[sz]);
  4:Result:=TTeglalap.Create(random(GetMaxX),random(GetMaxY),
                             random(Max-Min)+Min,random(Max-Min)+Min,
                             Szinek[sz]);
  5:Result:=TTeliTeglalap.Create(random(GetMaxX),random(GetMaxY),
                                 random(Max-Min)+Min,random(Max-Min)+Min,
                                 Szinek[sz]);
 end;
end;

{Alakzatok generlsa}
procedure TForm1.ListaGeneralas(Adb:word);
var i:byte; Akt:TPont;
begin
 for i:=1 to Adb do begin
  {egy vletlen alakzatot generlunk}
  Akt:=General;
  {berakjuk a listba}
  AlakzatLista.Add(Akt);
 end;
 {A darabszm frisstse a fejlcben}
 Fejlec;
end;

{Az alakzatok szmt a fejlcbe}
procedure TForm1.Fejlec;
begin
 Caption:='Alakzatok szma:'+IntToStr(AlakzatLista.Count);
end;

{Az alakzatok kirajzolsa}
procedure TForm1.Kirajzolas;
var i:integer;
begin
 for i:=1 to AlakzatLista.Count do
  with TPont(AlakzatLista.Items[i-1]) do
   Kirak(Szin,Image1.Canvas);
end;

{Egy vletlen mozgatsi lpst az Alakzatok lista minden objektumval}
{A Sender-t semmire sem hasznljuk, de csak a TNotifyEvent tpus}
{metdusok rendelhetk egy TTimer tpus objektum Ontimer esemnyhez}

procedure TForm1.EgyLepes(Sender:TObject);
var dx,dy:byte; Lement:boolean;
    Akt:TPont; i:integer;
begin
 {A darabszm frisstse a fejlcben}
 Fejlec;
 i:=1;
 while i<=AlakzatLista.Count do begin
  Akt:=AlakzatLista.Items[i-1];
  {A vletlen mozgshoz relatv koordintk}
  dx:=random(Tav)+1; dy:=random(Tav)+1;
  {A leszrmazott osztlyokat elbb vizsgljuk}
  if Akt is TKor then
   with TKor(Akt) do begin
    {a krket (teli, res) balra}
    Mozgat(-dx,dy*(integer(random(3))-1),Image1.Canvas);
    {lement-e a kpernyrl (x,y a kzppont)?}
    Lement:=(x+Sugar<0) or (x-Sugar>GetMaxX) or
            (y+Sugar<0) or (y-Sugar>GetMaxY);
    end
  else
  if Akt is TTeglalap then
   with TTeglalap(Akt) do begin
    {a tglalapokat lefel}
    Mozgat(dx*(integer(random(3))-1),dy,Image1.Canvas);
    {lement-e a kpernyrl (x,y a bal fels sarok)?}
    Lement:=(x+Szel<0) or (x>GetMaxX) or
            (y+Mag<0) or (y>GetMaxY);
   end
  else
  {Az s osztlyt ksbb vizsgljuk}
  {A felttel most felesleges, mert csak pont, kr s tglalap van a listn)}
  if Akt is TPont then
   with TPont(Akt) do begin
    {a pontot ssze-vissza}
    Mozgat(dx*(integer(random(3))-1),dy*(integer(random(3))-1),
     Image1.Canvas);
    {lement-e a kpernyrl?}
    Lement:=(x<0) or (x>GetMaxX) or
            (y<0) or (y>GetMaxY);
   end;
  if Lement then begin
   {az alakzat trlse}
   with Akt as TPont do
    Destroy(Image1.Canvas);
   {trljk a listbl}
   AlakzatLista.Delete(i-1);
  end else inc(i);
 end;
 {A darabszm frisstse a fejlcben}
 Fejlec;
end;

{A lista alakzatainak megszntetse}
procedure TForm1.ListaTorles;
var i:integer;
begin
 i:=1;
 while i<=AlakzatLista.Count do begin
  {Az alakzat megszntetse}
  TPont(AlakzatLista.Items[i-1]).Destroy(Image1.Canvas);
  {A listaelem trlse}
  AlakzatLista.Delete(i-1);
 end;
 {A darabszm frisstse a fejlcben}
 Fejlec;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 ListaGeneralas(random(db)+1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Kirajzolas;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Egylepes(Sender);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Ora.Enabled:=not Ora.Enabled;
 if Ora.Enabled then
  (Sender as TButton).Caption:='Mozgs Stop'
 else
  (Sender as TButton).Caption:='Mozgs Start';
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 ListaTorles;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 {A vletlen generlshoz}
 randomize;
 {A httrszn belltsa}
 with Image1,Canvas do begin
  Brush.Color:=HatterSzin;
  Pen.Color:=HatterSzin;
  Rectangle(0,0,Width,Height);
 end;
 {Az alakzatokat trol lista ltrehozsa}
 AlakzatLista:=TList.Create;
 {A darabszm frisstse a fejlcben}
 Fejlec;
 {Az idzt inicializlsa}
 Ora:=TTimer.Create(Self);
 Ora.Interval:=Ido;
 Ora.OnTimer:=EgyLepes;
 Ora.Enabled:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 {A lista elemeinek trlse}
 ListaTorles;
 {Az alakzatokat trol lista felszabadtsa}
 AlakzatLista.Free;
end;

end.



